using System;
using System.Collections.Generic;
using System.Text;
using EbiSoft.ZeroProxy.Servlets;

namespace EbiSoft.ZeroProxy
{
    public class ServletController
    {
        #region vOČ^

        private Dictionary<string, Type> m_servletTypes;
        private Dictionary<string, ServletBase> m_servletInstances;

        /// <summary>
        /// vOČ^̃Xg
        /// </summary>
        public Dictionary<string, Type> ServletTypes
        {
            get { return m_servletTypes; }
        }

        /// <summary>
        /// vOC̃CX^X̃Xg
        /// </summary>
        public Dictionary<string, ServletBase> ServletInstances
        {
            get { return m_servletInstances; }
        }

        #endregion

        /// <summary>
        /// ANZXT[ubgɐU蕪
        /// </summary>
        /// <param name="header">NGXgwb_</param>
        /// <param name="body">NGXg{fB</param>
        /// <returns>X|X</returns>
        public string DispatchAccess(byte[] header, byte[] body)
        {

        }

        /// <summary>
        /// vOČ^𑖍
        /// </summary>
        private void ListupPluginTypes()
        {
            m_servletTypes = new Dictionary<string, Type>();

            foreach (string dll in Directory.GetFiles(ImadokoUtility.ApplicationPath, "*.dll"))
            {
                try
                {
                    Assembly asm = Assembly.LoadFrom(dll);
                    foreach (Type type in asm.GetTypes())
                    {
                        // CX^Xł̂ǉ
                        if (type.IsSubclassOf(typeof(ServletBase)) && type.IsPublic && !type.IsAbstract)
                        {
                            m_servletTypes.Add(type.Name, type);
                            type.GetCustomAttributes(typeof(ServletAttribute), false);
                        }
                    }
                }
                catch (Exception) { }
            }
        }

        /// <summary>
        /// vOCCX^X
        /// </summary>
        private void CreateInstances()
        {
            m_servletInstances = new Dictionary<string, ServletBase>();

            foreach (string key in ServletTypes.Keys)
            {
                try
                {
                    object[] attributes = ServletTypes[key].GetCustomAttributes(typeof(ServletAttribute), false);
                    ServletBase plugin = ServletTypes[key].Assembly.CreateInstance(ServletTypes[key].FullName) as ServletBase;
                    m_servletInstances.Add(key, plugin);

                }
                catch (Exception) { }
            }
        }
    }
}
