using System;
using System.Collections.Generic;
using System.Text;

namespace EbiSoft.ZeroProxy
{
    /// <summary>
    /// ݒǗNX
    /// </summary>
    public class Setting
    {
        #region Singleton 

        private static Setting m_instance = null;

        /// <summary>
        /// CX^X
        /// </summary>
        public static Setting Instance
        {
            get
            {
                if (m_instance == null)
                {
                    throw new Exception();
                }
                return m_instance;
            }
        }

        #endregion

        /// <summary>
        /// ݒNX
        /// </summary>
        /// <param name="settingFile">ǂݍސݒt@C</param>
        public static void Initialize(string settingFile)
        {
            m_instance = new Setting(settingFile);
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="settingFile">ݒt@C</param>
        protected Setting(string settingFile)
        {
            m_settingFile = settingFile;
            m_setting = new SettingData();
            Load();
        }

        private SettingData m_setting;
        private string m_settingFile;

        /// <summary>
        /// ݒf[^
        /// </summary>
        public SettingData SettingData
        {
            get { return m_setting; }
            set { m_setting = value; }
        }

        /// <summary>
        /// ݒ̓ǂݍ
        /// </summary>
        public void Load()
        {
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(SettingData));
                Stream stream = new FileStream(m_settingFile, FileMode.Open, FileAccess.Read, FileShare.ReadWrite);
                m_setting = (SettingData)serializer.Deserialize(stream);
                stream.Close();
            }
            catch (Exception)
            { }
        }

        /// <summary>
        /// ݒ̕ۑ
        /// </summary>
        public void Save()
        {
            try
            {
                XmlSerializer serializer = new XmlSerializer(typeof(SettingData));
                Stream stream = new FileStream(m_settingFile, FileMode.Create, FileAccess.Write, FileShare.ReadWrite);
                serializer.Serialize(stream, m_setting);
                stream.Close();
            }
            catch (Exception)
            { }
        }
    }

    /// <summary>
    /// ݒf[^
    /// </summary>
    public class SettingData
    {
    }
}
